searchData={"items":[{"type":"module","title":"Astro","doc":"Functions for basic astronomical observations such\nas sunrise, sunset, solstice, equinox, moonrise,\nmoonset and moon phase.","ref":"Astro.html"},{"type":"function","title":"Astro.date_time_lunar_phase_at_or_after/2","doc":"Returns the date time of a given\nlunar phase at or after a given\ndate time or date.","ref":"Astro.html#date_time_lunar_phase_at_or_after/2"},{"type":"function","title":"Arguments - Astro.date_time_lunar_phase_at_or_after/2","doc":"* `date_time` is a `DateTime` or a `Date` or\n  any struct that meets the requirements of\n  `t:Calendar.date` or `t:Calendar.datetime`\n\n* `phase` is the required lunar phase expressed\n  as a float number of degrees between `0.0` and\n  `360.0`","ref":"Astro.html#date_time_lunar_phase_at_or_after/2-arguments"},{"type":"function","title":"Returns - Astro.date_time_lunar_phase_at_or_after/2","doc":"* `{:ok, date_time}` at which the phase occurs or\n\n* `{:error, {module, reason}}`","ref":"Astro.html#date_time_lunar_phase_at_or_after/2-returns"},{"type":"function","title":"Example - Astro.date_time_lunar_phase_at_or_after/2","doc":"iex> Astro.date_time_lunar_phase_at_or_after(~D[2021-08-01], Astro.Lunar.full_moon())\n    {:ok, ~U[2021-08-22 12:01:02.000000Z]}","ref":"Astro.html#date_time_lunar_phase_at_or_after/2-example"},{"type":"function","title":"Astro.date_time_lunar_phase_at_or_before/2","doc":"Returns the date time of a given\nlunar phase at or before a given\ndate time or date.","ref":"Astro.html#date_time_lunar_phase_at_or_before/2"},{"type":"function","title":"Arguments - Astro.date_time_lunar_phase_at_or_before/2","doc":"* `date_time` is a `DateTime` or a `Date` or\n  any struct that meets the requirements of\n  `t:Calendar.date` or `t:Calendar.datetime`\n\n* `phase` is the required lunar phase expressed\n  as a float number of degrees between `0` and\n  `3660`","ref":"Astro.html#date_time_lunar_phase_at_or_before/2-arguments"},{"type":"function","title":"Returns - Astro.date_time_lunar_phase_at_or_before/2","doc":"* `{:ok, date_time}` at which the phase occurs or\n\n* `{:error, {module, reason}}`","ref":"Astro.html#date_time_lunar_phase_at_or_before/2-returns"},{"type":"function","title":"Example - Astro.date_time_lunar_phase_at_or_before/2","doc":"iex> Astro.date_time_lunar_phase_at_or_before(~D[2021-08-01], Astro.Lunar.new_moon())\n    {:ok, ~U[2021-07-10 01:15:33.000000Z]}","ref":"Astro.html#date_time_lunar_phase_at_or_before/2-example"},{"type":"function","title":"Astro.date_time_new_moon_at_or_after/1","doc":"Returns the date time of the new\nmoon at or after a given date or\ndate time.","ref":"Astro.html#date_time_new_moon_at_or_after/1"},{"type":"function","title":"Arguments - Astro.date_time_new_moon_at_or_after/1","doc":"* `date_time` is a `DateTime` or a `Date` or\n  any struct that meets the requirements of\n  `t:Calendar.date` or `t:Calendar.datetime`","ref":"Astro.html#date_time_new_moon_at_or_after/1-arguments"},{"type":"function","title":"Returns - Astro.date_time_new_moon_at_or_after/1","doc":"* `{:ok, date_time}` at which the new moon occurs or\n\n* `{:error, {module, reason}}`","ref":"Astro.html#date_time_new_moon_at_or_after/1-returns"},{"type":"function","title":"Example - Astro.date_time_new_moon_at_or_after/1","doc":"iex> Astro.date_time_new_moon_at_or_after ~D[2021-08-23]\n    {:ok, ~U[2021-09-07 00:50:43.000000Z]}","ref":"Astro.html#date_time_new_moon_at_or_after/1-example"},{"type":"function","title":"Astro.date_time_new_moon_before/1","doc":"Returns the date time of the new\nmoon before a given date or date time.","ref":"Astro.html#date_time_new_moon_before/1"},{"type":"function","title":"Arguments - Astro.date_time_new_moon_before/1","doc":"* `date_time` is a `DateTime` or a `Date` or\n  any struct that meets the requirements of\n  `t:Calendar.date` or `t:Calendar.datetime`","ref":"Astro.html#date_time_new_moon_before/1-arguments"},{"type":"function","title":"Returns - Astro.date_time_new_moon_before/1","doc":"* `{:ok, date_time}` at which the new moon occurs or\n\n* `{:error, {module, reason}}`","ref":"Astro.html#date_time_new_moon_before/1-returns"},{"type":"function","title":"Example - Astro.date_time_new_moon_before/1","doc":"iex> Astro.date_time_new_moon_before ~D[2021-08-23]\n    {:ok, ~U[2021-08-08 13:49:07.000000Z]}","ref":"Astro.html#date_time_new_moon_before/1-example"},{"type":"function","title":"Astro.declination/3","doc":"beta and lambda in degrees","ref":"Astro.html#declination/3"},{"type":"function","title":"Astro.equinox/2","doc":"Returns the datetime in UTC for either the\nMarch or September equinox.","ref":"Astro.html#equinox/2"},{"type":"function","title":"Arguments - Astro.equinox/2","doc":"* `year` is the gregorian year for which the equinox is\n  to be calculated\n\n* `event` is either `:march` or `:september` indicating\n  which of the two annual equinox datetimes is required","ref":"Astro.html#equinox/2-arguments"},{"type":"function","title":"Returns - Astro.equinox/2","doc":"* `{:ok, datetime}` representing the UTC datetime of\n  the equinox","ref":"Astro.html#equinox/2-returns"},{"type":"function","title":"Examples - Astro.equinox/2","doc":"iex> Astro.equinox 2019, :march\n    {:ok, ~U[2019-03-20 21:58:06Z]}\n    iex> Astro.equinox 2019, :september\n    {:ok, ~U[2019-09-23 07:49:30Z]}","ref":"Astro.html#equinox/2-examples"},{"type":"function","title":"Notes - Astro.equinox/2","doc":"This equinox calculation is expected to be accurate\nto within 2 minutes for the years 1000 CE to 3000 CE.\n\nAn equinox is commonly regarded as the instant of\ntime when the plane of Earth's equator passes through\nthe center of the Sun. This occurs twice each year:\naround 20 March and 23 September.\n\nIn other words, it is the moment at which the\ncenter of the visible Sun is directly above the equator.","ref":"Astro.html#equinox/2-notes"},{"type":"function","title":"Astro.hours_of_daylight/2","doc":"Returns the number of hours of daylight for a given\nlocation on a given date.","ref":"Astro.html#hours_of_daylight/2"},{"type":"function","title":"Arguments - Astro.hours_of_daylight/2","doc":"* `location` is the latitude, longitude and\n  optionally elevation for the desired hours of\n  daylight. It can be expressed as:\n\n  * `{lng, lat}` - a tuple with longitude and latitude\n    as floating point numbers. **Note** the order of the\n    arguments.\n  * a `Geo.Point.t` struct to represent a location without elevation\n  * a `Geo.PointZ.t` struct to represent a location and elevation\n\n* `date` is any date in the Gregorian\n  calendar (for example, `Calendar.ISO`)","ref":"Astro.html#hours_of_daylight/2-arguments"},{"type":"function","title":"Returns - Astro.hours_of_daylight/2","doc":"* `{:ok, time}` where `time` is a `Time.t()`","ref":"Astro.html#hours_of_daylight/2-returns"},{"type":"function","title":"Examples - Astro.hours_of_daylight/2","doc":"iex> Astro.hours_of_daylight {151.20666584, -33.8559799094}, ~D[2019-12-07]\n    {:ok, ~T[14:18:45]}\n\n    # No sunset in summer\n    iex> Astro.hours_of_daylight {-62.3481, 82.5018}, ~D[2019-06-07]\n    {:ok, ~T[23:59:59]}\n\n    # No sunrise in winter\n    iex> Astro.hours_of_daylight {-62.3481, 82.5018}, ~D[2019-12-07]\n    {:ok, ~T[00:00:00]}","ref":"Astro.html#hours_of_daylight/2-examples"},{"type":"function","title":"Notes - Astro.hours_of_daylight/2","doc":"In latitudes above the polar circles (approximately\n+/- 66.5631 degrees) there will be no hours of daylight\nin winter and 24 hours of daylight in summer.","ref":"Astro.html#hours_of_daylight/2-notes"},{"type":"function","title":"Astro.illuminated_fraction_of_moon_at/1","doc":"Returns the illumination of the moon\nas a fraction for a given date or date time.","ref":"Astro.html#illuminated_fraction_of_moon_at/1"},{"type":"function","title":"Arguments - Astro.illuminated_fraction_of_moon_at/1","doc":"* `date_time` is a `DateTime` or a `Date` or\n  any struct that meets the requirements of\n  `t:Calendar.date` or `t:Calendar.datetime`","ref":"Astro.html#illuminated_fraction_of_moon_at/1-arguments"},{"type":"function","title":"Returns - Astro.illuminated_fraction_of_moon_at/1","doc":"* a `float` value between `0.0` and `1.0`\n  representing the fractional illumination of\n  the moon.","ref":"Astro.html#illuminated_fraction_of_moon_at/1-returns"},{"type":"function","title":"Example - Astro.illuminated_fraction_of_moon_at/1","doc":"iex> Astro.illuminated_fraction_of_moon_at(~D[2017-03-16])\n    0.8884442367681415\n\n    iex> Astro.illuminated_fraction_of_moon_at(~D[1992-04-12])\n    0.6786428237168787","ref":"Astro.html#illuminated_fraction_of_moon_at/1-example"},{"type":"macro","title":"Astro.is_lunar_phase/1","doc":"","ref":"Astro.html#is_lunar_phase/1"},{"type":"function","title":"Astro.lunar_phase_at/1","doc":"Returns the lunar phase as a\nfloat number of degrees at a given\ndate or date time.","ref":"Astro.html#lunar_phase_at/1"},{"type":"function","title":"Arguments - Astro.lunar_phase_at/1","doc":"* `date_time` is a `DateTime`, `Date` or\n  a `moment` which is a float number of days\n  since `0000-01-01`","ref":"Astro.html#lunar_phase_at/1-arguments"},{"type":"function","title":"Returns - Astro.lunar_phase_at/1","doc":"* the lunar phase as a float number of\n  degrees.","ref":"Astro.html#lunar_phase_at/1-returns"},{"type":"function","title":"Example - Astro.lunar_phase_at/1","doc":"iex> Astro.lunar_phase_at ~U[2021-08-22 12:01:02.170362Z]\n    180.00001498208536\n\n    iex> Astro.lunar_phase_at(~U[2021-07-10 01:18:25.422335Z])\n    0.021567106773019873","ref":"Astro.html#lunar_phase_at/1-example"},{"type":"function","title":"Astro.lunar_phase_emoji/1","doc":"Returns the moon phase as a UTF8 binary\nrepresenting an emoji of the moon phase.","ref":"Astro.html#lunar_phase_emoji/1"},{"type":"function","title":"Arguments - Astro.lunar_phase_emoji/1","doc":"* `phase` is a moon phase between `0.0` and `360.0`","ref":"Astro.html#lunar_phase_emoji/1-arguments"},{"type":"function","title":"Returns - Astro.lunar_phase_emoji/1","doc":"* A single grapheme string representing the [Unicode\n  moon phase emoji](https://unicode-table.com/en/sets/moon/)","ref":"Astro.html#lunar_phase_emoji/1-returns"},{"type":"function","title":"Examples - Astro.lunar_phase_emoji/1","doc":"iex> Astro.lunar_phase_emoji 0\n    \"🌑\"\n    iex> Astro.lunar_phase_emoji 45\n    \"🌒\"\n    iex> Astro.lunar_phase_emoji 90\n    \"🌓\"\n    iex> Astro.lunar_phase_emoji 135\n    \"🌔\"\n    iex> Astro.lunar_phase_emoji 180\n    \"🌕\"\n    iex> Astro.lunar_phase_emoji 245\n    \"🌖\"\n    iex> Astro.lunar_phase_emoji 270\n    \"🌗\"\n    iex> Astro.lunar_phase_emoji 320\n    \"🌘\"\n    iex> Astro.lunar_phase_emoji 360\n    \"🌑\"\n\n    iex> ~U[2021-08-22 12:01:02.170362Z]\n    ...> |> Astro.lunar_phase_at()\n    ...> |> Astro.lunar_phase_emoji()\n    \"🌕\"","ref":"Astro.html#lunar_phase_emoji/1-examples"},{"type":"function","title":"Astro.moon_position_at/1","doc":"Returns a `t:Geo.PointZ` containing\nthe right ascension and declination of\nthe moon at a given date or date time.","ref":"Astro.html#moon_position_at/1"},{"type":"function","title":"Arguments - Astro.moon_position_at/1","doc":"* `date_time` is a `DateTime` or a `Date` or\n  any struct that meets the requirements of\n  `t:Calendar.date` or `t:Calendar.datetime`","ref":"Astro.html#moon_position_at/1-arguments"},{"type":"function","title":"Returns - Astro.moon_position_at/1","doc":"* a `t:Geo.PointZ` struct with coordinates\n  `{right_ascension, declination, distance}` with properties\n  `%{reference: :celestial, object: :moon}`\n  `distance` is in meters.","ref":"Astro.html#moon_position_at/1-returns"},{"type":"function","title":"Example - Astro.moon_position_at/1","doc":"iex> Astro.moon_position_at(~D[1992-04-12]) |> Astro.Location.round(6)\n    %Geo.PointZ{\n      coordinates: {134.697888, 13.765243, 5.511320224169038e19},\n      properties: %{object: :moon, reference: :celestial},\n      srid: nil\n    }","ref":"Astro.html#moon_position_at/1-example"},{"type":"function","title":"Astro.right_ascension/3","doc":"beta and lambda in degrees","ref":"Astro.html#right_ascension/3"},{"type":"function","title":"Astro.solar_noon/2","doc":"Returns solar noon for a\ngiven date and location as\na UTC datetime","ref":"Astro.html#solar_noon/2"},{"type":"function","title":"Arguments - Astro.solar_noon/2","doc":"* `location` is the latitude, longitude and\n  optionally elevation for the desired solar noon\n  time. It can be expressed as:\n\n  * `{lng, lat}` - a tuple with longitude and latitude\n    as floating point numbers. **Note** the order of the\n    arguments.\n  * a `Geo.Point.t` struct to represent a location without elevation\n  * a `Geo.PointZ.t` struct to represent a location and elevation\n\n* `date` is any date in the Gregorian\n  calendar (for example, `Calendar.ISO`)","ref":"Astro.html#solar_noon/2-arguments"},{"type":"function","title":"Returns - Astro.solar_noon/2","doc":"* a UTC datetime representing solar noon\n  at the given location for the given date","ref":"Astro.html#solar_noon/2-returns"},{"type":"function","title":"Example - Astro.solar_noon/2","doc":"iex> Astro.solar_noon {151.20666584, -33.8559799094}, ~D[2019-12-06]\n    {:ok, ~U[2019-12-06 01:45:42Z]}","ref":"Astro.html#solar_noon/2-example"},{"type":"function","title":"Notes - Astro.solar_noon/2","doc":"Solar noon is the moment when the Sun passes a\nlocation's meridian and reaches its highest position\nin the sky. In most cases, it doesn't happen at 12 o'clock.\n\nAt solar noon, the Sun reaches its\nhighest position in the sky as it passes the\nlocal meridian.","ref":"Astro.html#solar_noon/2-notes"},{"type":"function","title":"Astro.solstice/2","doc":"Returns the datetime in UTC for either the\nJune or December solstice.","ref":"Astro.html#solstice/2"},{"type":"function","title":"Arguments - Astro.solstice/2","doc":"* `year` is the gregorian year for which the solstice is\n  to be calculated\n\n* `event` is either `:june` or `:december` indicating\n  which of the two annual solstice datetimes is required","ref":"Astro.html#solstice/2-arguments"},{"type":"function","title":"Returns - Astro.solstice/2","doc":"* `{:ok, datetime}` representing the UTC datetime of\n  the solstice","ref":"Astro.html#solstice/2-returns"},{"type":"function","title":"Examples - Astro.solstice/2","doc":"iex> Astro.solstice 2019, :december\n    {:ok, ~U[2019-12-22 04:18:57Z]}\n    iex> Astro.solstice 2019, :june\n    {:ok, ~U[2019-06-21 15:53:45Z]}","ref":"Astro.html#solstice/2-examples"},{"type":"function","title":"Notes - Astro.solstice/2","doc":"This solstice calculation is expected to be accurate\nto within 2 minutes for the years 1000 CE to 3000 CE.\n\nA solstice is an event occurring when the Sun appears\nto reach its most northerly or southerly excursion\nrelative to the celestial equator on the celestial\nsphere. Two solstices occur annually, around June 21\nand December 21.\n\nThe seasons of the year are determined by\nreference to both the solstices and the equinoxes.\n\nThe term solstice can also be used in a broader\nsense, as the day when this occurs. The day of a\nsolstice in either hemisphere has either the most\nsunlight of the year (summer solstice) or the least\nsunlight of the year (winter solstice) for any place\nother than the Equator.\n\nAlternative terms, with no ambiguity as to which\nhemisphere is the context, are \"June solstice\" and\n\"December solstice\", referring to the months in\nwhich they take place every year.","ref":"Astro.html#solstice/2-notes"},{"type":"function","title":"Astro.sun_apparent_longitude/1","doc":"Returns solar longitude for a\ngiven date. Solar longitude is used\nto identify the seasons.","ref":"Astro.html#sun_apparent_longitude/1"},{"type":"function","title":"Arguments - Astro.sun_apparent_longitude/1","doc":"* `date` is any date in the Gregorian\n  calendar (for example, `Calendar.ISO`)","ref":"Astro.html#sun_apparent_longitude/1-arguments"},{"type":"function","title":"Returns - Astro.sun_apparent_longitude/1","doc":"* a `float` number of degrees between 0 and\n  360 representing the solar longitude\n  on `date`","ref":"Astro.html#sun_apparent_longitude/1-returns"},{"type":"function","title":"Examples - Astro.sun_apparent_longitude/1","doc":"iex> Astro.sun_apparent_longitude ~D[2019-03-21]\n    0.08035853207991295\n    iex> Astro.sun_apparent_longitude ~D[2019-06-22]\n    90.32130455695378\n    iex> Astro.sun_apparent_longitude ~D[2019-09-23]\n    179.68691978440197\n    iex> Astro.sun_apparent_longitude ~D[2019-12-23]\n    270.83941087483504","ref":"Astro.html#sun_apparent_longitude/1-examples"},{"type":"function","title":"Notes - Astro.sun_apparent_longitude/1","doc":"Solar longitude (the ecliptic longitude of the sun)\nin effect describes the position of the earth in its\norbit, being zero at the moment of the vernal\nequinox.\n\nSince it is based on how far the earth has moved\nin its orbit since the equinox, it is a measure of\nwhat time of the tropical year (the year of seasons)\nwe are in, but without the inaccuracies of a calendar\ndate, which is perturbed by leap years and calendar\nimperfections.","ref":"Astro.html#sun_apparent_longitude/1-notes"},{"type":"function","title":"Astro.sun_azimuth_elevation/2","doc":"Returns a tuple `{azimuth, altitude}` for a given\ndate time and location.","ref":"Astro.html#sun_azimuth_elevation/2"},{"type":"function","title":"Arguments - Astro.sun_azimuth_elevation/2","doc":"* `location` is the latitude, longitude and\n  optionally elevation for the desired sunrise\n  azimuth and altitude. It can be expressed as:\n\n  * `{lng, lat}` - a tuple with longitude and latitude\n    as floating point numbers. **Note** the order of the\n    arguments.\n  * a `Geo.Point.t` struct to represent a location without elevation\n  * a `Geo.PointZ.t` struct to represent a location and elevation\n\n* `date_time` is a `DateTime` any struct that meets the\n  requirements of `t:Calendar.datetime`.","ref":"Astro.html#sun_azimuth_elevation/2-arguments"},{"type":"function","title":"Returns - Astro.sun_azimuth_elevation/2","doc":"* a tuple of the format `{azimith, altitude}` which are\n  expressed in float degrees.","ref":"Astro.html#sun_azimuth_elevation/2-returns"},{"type":"function","title":"Example - Astro.sun_azimuth_elevation/2","doc":"iex> {:ok, date_time} = DateTime.new(~D[2023-05-17], ~T[12:47:00], \"Australia/Sydney\")\n    iex> location = {151.1637781, -33.5145852}\n    iex> {_azimuth, _altitude} = Astro.sun_azimuth_elevation(location, date_time)","ref":"Astro.html#sun_azimuth_elevation/2-example"},{"type":"function","title":"Astro.sun_position_at/1","doc":"Returns a `t:Geo.PointZ` containing\nthe right ascension and declination of\nthe sun at a given date or date time.","ref":"Astro.html#sun_position_at/1"},{"type":"function","title":"Arguments - Astro.sun_position_at/1","doc":"* `date_time` is a `DateTime` or a `Date` or\n  any struct that meets the requirements of\n  `t:Calendar.date` or `t:Calendar.datetime`","ref":"Astro.html#sun_position_at/1-arguments"},{"type":"function","title":"Returns - Astro.sun_position_at/1","doc":"* a `t:Geo.PointZ` struct with coordinates\n  `{right_ascension, declination, distance}` with properties\n  `%{reference: :celestial, object: :sun}`.\n  `distance` is in meters.","ref":"Astro.html#sun_position_at/1-returns"},{"type":"function","title":"Example - Astro.sun_position_at/1","doc":"iex> Astro.sun_position_at(~D[1992-10-13])\n    %Geo.PointZ{\n      coordinates: {-161.6185428539835, -7.785325031528879, 149169604711.3518},\n      properties: %{object: :sun, reference: :celestial},\n      srid: nil\n    }","ref":"Astro.html#sun_position_at/1-example"},{"type":"function","title":"Astro.sunrise/3","doc":"Calculates the sunrise for a given location and date.\n\nSunrise is the moment when the upper limb of\nthe sun appears on the horizon in the morning.","ref":"Astro.html#sunrise/3"},{"type":"function","title":"Arguments - Astro.sunrise/3","doc":"* `location` is the latitude, longitude and\n  optionally elevation for the desired sunrise\n  time. It can be expressed as:\n\n  * `{lng, lat}` - a tuple with longitude and latitude\n    as floating point numbers. **Note** the order of the\n    arguments.\n  * a `Geo.Point.t` struct to represent a location without elevation\n  * a `Geo.PointZ.t` struct to represent a location and elevation\n\n* `date` is a `t:Date`, `t:NaiveDateTime` or `t:DateTime`\n  to indicate the date of the year in which\n  the sunrise time is required.\n\n* `options` is a keyword list of options.","ref":"Astro.html#sunrise/3-arguments"},{"type":"function","title":"Options - Astro.sunrise/3","doc":"* `solar_elevation` represents the type of sunrise\n  required. The default is `:geometric` which equates to\n  a solar elevation of 90°. In this case the calulation\n  also accounts for refraction and elevation to return a\n  result which accords with the eyes perception. Other\n  solar elevations are:\n\n\n  * `:civil` representing a solar elevation of 96.0°. At this\n    point the sun is just below the horizon so there is\n    generally enough natural light to carry out most\n    outdoor activities.\n\n  * `:nautical` representing a solar elevation of 102.0°\n    This is the point at which the horizon is just barely visible\n    and the moon and stars can still be used for navigation.\n\n  * `:astronomical`representing a solar elevation of 108.0°.\n    This is the point beyond which astronomical observation\n    becomes impractical.\n\n  * Any floating point number representing the desired\n    solar elevation.\n\n* `:time_zone` is the time zone to in which the sunrise\n  is requested. The default is `:default` in which\n  the sunrise time is reported in the time zone of\n  the requested location. Any other time zone name\n  supported by the option `:time_zone_database` is\n  acceptabe.\n\n* `:time_zone_database` represents the module that\n  implements the `Calendar.TimeZoneDatabase` behaviour.\n  The default is `Tzdata.TimeZoneDatabase`.","ref":"Astro.html#sunrise/3-options"},{"type":"function","title":"Returns - Astro.sunrise/3","doc":"* a `DateTime.t` representing the time of sunrise in the\n  requested timzone at the requested location or\n\n* `{:error, :time_zone_not_found}` if the requested\n  time zone is unknown\n\n* `{:error, :no_time}` if for the requested date\n  and location there is no sunrise. This can occur at\n  very high latitudes during summer and winter.","ref":"Astro.html#sunrise/3-returns"},{"type":"function","title":"Examples - Astro.sunrise/3","doc":"# Sunrise in Sydney, Australia\n    Astro.sunrise({151.20666584, -33.8559799094}, ~D[2019-12-04])\n    {:ok, #DateTime<2019-12-04 05:37:00.000000+11:00 AEDT Australia/Sydney>}\n\n    # Sunrise in Alert, Nanavut, Canada\n    Astro.sunrise({-62.3481, 82.5018}, ~D[2019-12-04])\n    {:error, :no_time}","ref":"Astro.html#sunrise/3-examples"},{"type":"function","title":"Astro.sunset/3","doc":"Calculates the sunset for a given location and date.\n\nSunset is the moment when the upper limb of\nthe sun disappears below the horizon in the evening.","ref":"Astro.html#sunset/3"},{"type":"function","title":"Arguments - Astro.sunset/3","doc":"* `location` is the latitude, longitude and\n  optionally elevation for the desired sunrise\n  time. It can be expressed as:\n\n  * `{lng, lat}` - a tuple with longitude and latitude\n    as floating point numbers. **Note** the order of the\n    arguments.\n  * a `Geo.Point.t` struct to represent a location without elevation\n  * a `Geo.PointZ.t` struct to represent a location and elevation\n\n* `date` is a `t:Date`, `t:NaiveDateTime` or `t:DateTime`\n  to indicate the date of the year in which\n  the sunset time is required.\n\n* `options` is a keyword list of options.","ref":"Astro.html#sunset/3-arguments"},{"type":"function","title":"Options - Astro.sunset/3","doc":"* `solar_elevation` represents the type of sunset\n  required. The default is `:geometric` which equates to\n  a solar elevation of 90°. In this case the calulation\n  also accounts for refraction and elevation to return a\n  result which accords with the eyes perception. Other\n  solar elevations are:\n\n  * `:civil` representing a solar elevation of 96.0°. At this\n    point the sun is just below the horizon so there is\n    generally enough natural light to carry out most\n    outdoor activities.\n\n  * `:nautical` representing a solar elevation of 102.0°\n    This is the point at which the horizon is just barely visible\n    and the moon and stars can still be used for navigation.\n\n  * `:astronomical`representing a solar elevation of 108.0°.\n    This is the point beyond which astronomical observation\n    becomes impractical.\n\n  * Any floating point number representing the desired\n    solar elevation.\n\n* `:time_zone` is the time zone to in which the sunset\n  is requested. The default is `:default` in which\n  the sunset time is reported in the time zone of\n  the requested location. Any other time zone name\n  supported by the option `:time_zone_database` is\n  acceptabe.\n\n* `:time_zone_database` represents the module that\n  implements the `Calendar.TimeZoneDatabase` behaviour.\n  The default is `Tzdata.TimeZoneDatabase`.","ref":"Astro.html#sunset/3-options"},{"type":"function","title":"Returns - Astro.sunset/3","doc":"* a `t:DateTime` representing the time of sunset in the\n  requested time zone at the requested location or\n\n* `{:error, :time_zone_not_found}` if the requested\n  time zone is unknown\n\n* `{:error, :no_time}` if for the requested date\n  and location there is no sunset. This can occur at\n  very high latitudes during summer and winter.","ref":"Astro.html#sunset/3-returns"},{"type":"function","title":"Examples - Astro.sunset/3","doc":"# Sunset in Sydney, Australia\n    Astro.sunset({151.20666584, -33.8559799094}, ~D[2019-12-04])\n    {:ok, #DateTime<2019-12-04 19:53:00.000000+11:00 AEDT Australia/Sydney>}\n\n    # Sunset in Alert, Nanavut, Canada\n    Astro.sunset({-62.3481, 82.5018}, ~D[2019-12-04])\n    {:error, :no_time}","ref":"Astro.html#sunset/3-examples"},{"type":"type","title":"Astro.altitude/0","doc":"","ref":"Astro.html#t:altitude/0"},{"type":"type","title":"Astro.angle/0","doc":"","ref":"Astro.html#t:angle/0"},{"type":"type","title":"Astro.date/0","doc":"","ref":"Astro.html#t:date/0"},{"type":"type","title":"Astro.degrees/0","doc":"","ref":"Astro.html#t:degrees/0"},{"type":"type","title":"Astro.latitude/0","doc":"","ref":"Astro.html#t:latitude/0"},{"type":"type","title":"Astro.location/0","doc":"","ref":"Astro.html#t:location/0"},{"type":"type","title":"Astro.longitude/0","doc":"","ref":"Astro.html#t:longitude/0"},{"type":"type","title":"Astro.meters/0","doc":"","ref":"Astro.html#t:meters/0"},{"type":"type","title":"Astro.options/0","doc":"","ref":"Astro.html#t:options/0"},{"type":"type","title":"Astro.phase/0","doc":"","ref":"Astro.html#t:phase/0"},{"type":"module","title":"Astro.Earth","doc":"Constants and astronomical calculations\nrelated to the earth.","ref":"Astro.Earth.html"},{"type":"function","title":"Astro.Earth.adjusted_solar_elevation/2","doc":"Adjusts the solar elevation to be the apparent angle\nat sunrise if the requested angle is `:geometric`\n(or 90°)","ref":"Astro.Earth.html#adjusted_solar_elevation/2"},{"type":"function","title":"Arguments - Astro.Earth.adjusted_solar_elevation/2","doc":"* `solar_elevation` is the requested solar elevation\n  in degress. It will be 90° for sunrise and sunset.\n\n* `elevation` is elevation in meters","ref":"Astro.Earth.html#adjusted_solar_elevation/2-arguments"},{"type":"function","title":"Returns - Astro.Earth.adjusted_solar_elevation/2","doc":"* The solar elevation angle which, if solar elevation is\n  exactly 90.0 degrees, is adjusted for refraction,\n  elevation and solar radius.","ref":"Astro.Earth.html#adjusted_solar_elevation/2-returns"},{"type":"function","title":"Astro.Earth.earth_radius/0","doc":"Returns the radius of the earth in kilometers","ref":"Astro.Earth.html#earth_radius/0"},{"type":"function","title":"Astro.Earth.elevation_adjustment/1","doc":"Adjusts the solar elevation to account\nfor the elevation of the requested location","ref":"Astro.Earth.html#elevation_adjustment/1"},{"type":"function","title":"Arguments - Astro.Earth.elevation_adjustment/1","doc":"* `elevation` is elevation in meters","ref":"Astro.Earth.html#elevation_adjustment/1-arguments"},{"type":"function","title":"Returns - Astro.Earth.elevation_adjustment/1","doc":"* The solar elevation angle adjusted for the elevation","ref":"Astro.Earth.html#elevation_adjustment/1-returns"},{"type":"function","title":"Astro.Earth.nutation/1","doc":"","ref":"Astro.Earth.html#nutation/1"},{"type":"function","title":"Astro.Earth.obliquity/0","doc":"Returns the obliquity of the earth","ref":"Astro.Earth.html#obliquity/0"},{"type":"function","title":"Astro.Earth.refraction/0","doc":"Returns an estimate of the effect of refraction\napplied to the calculation of sunrise and\nsunset times.\n\nSunrise actually occurs before the sun truly\nreaches the horizon because earth's atmosphere\nrefracts the Sun's image. At the horizon, the average\namount of refraction is 34 arcminutes, though this\namount varies based on atmospheric conditions.\n\nThis effect is especially powerful for objects\nthat appear close to the horizon, such as the\nrising or setting sun, because the light rays\nenter the earth's atmosphere at a particularly\nshallow angle. Because of refraction, the sun\nmay be seen for several minutes before it actually\nrises in the morning and after it sets in the\nevening.","ref":"Astro.Earth.html#refraction/0"},{"type":"function","title":"Astro.Earth.solar_radius/0","doc":"Returns the suns apparent radius at sunrise/sunset.\n\nUnlike most other solar measurements, sunrise occurs\nwhen the Sun's upper limb, rather than its center,\nappears to cross the horizon. The apparent radius of\nthe Sun at the horizon is 16 arcminutes.","ref":"Astro.Earth.html#solar_radius/0"},{"type":"module","title":"Astro.Guards","doc":"","ref":"Astro.Guards.html"},{"type":"function","title":"Astro.Guards.datetime/0","doc":"","ref":"Astro.Guards.html#datetime/0"},{"type":"macro","title":"Astro.Guards.is_alt/1","doc":"","ref":"Astro.Guards.html#is_alt/1"},{"type":"macro","title":"Astro.Guards.is_lat/1","doc":"","ref":"Astro.Guards.html#is_lat/1"},{"type":"macro","title":"Astro.Guards.is_lng/1","doc":"","ref":"Astro.Guards.html#is_lng/1"},{"type":"module","title":"Astro.Lunar","doc":"Calulates lunar phases.\n\nEach of the phases of the Moon is defined by the\nangle between the Moon and Sun in the sky. When the Moon\nis in between the Earth and the Sun, so that there is nearly a\nzero degree separation, we see a New Moon.\n\nBecause the orbit of the Moon is tilted in relation to the\nEarth’s orbit around the Sun, a New Moon can still be as much\nas 5.2 degrees away from the Sun, thus why there isn't a\nsolar eclipse every month.\n\nA crescent moon is 45 degrees from the Sun, a quarter moon\nis 90 degrees from the Sun, a gibbous moon is 135 degrees\nfrom the Sun, and the Full Moon is 180 degrees away from\nthe Sun.","ref":"Astro.Lunar.html"},{"type":"function","title":"Astro.Lunar.date_time_lunar_phase_at_or_after/2","doc":"Returns the date time of a given\nlunar phase at or after a given\ndate time or date.","ref":"Astro.Lunar.html#date_time_lunar_phase_at_or_after/2"},{"type":"function","title":"Arguments - Astro.Lunar.date_time_lunar_phase_at_or_after/2","doc":"* a `moment` which is a float number of days\n  since `0000-01-01`\n\n* `phase` is the required lunar phase expressed\n  as a float number of degrees between `0` and\n  `3660`","ref":"Astro.Lunar.html#date_time_lunar_phase_at_or_after/2-arguments"},{"type":"function","title":"Returns - Astro.Lunar.date_time_lunar_phase_at_or_after/2","doc":"* a `t:Time.moment()` which is a float number of days\n  since `0000-01-01`","ref":"Astro.Lunar.html#date_time_lunar_phase_at_or_after/2-returns"},{"type":"function","title":"Example - Astro.Lunar.date_time_lunar_phase_at_or_after/2","doc":"iex> Astro.Lunar.date_time_lunar_phase_at_or_after(738368, Astro.Lunar.full_moon())\n    738389.5007195254","ref":"Astro.Lunar.html#date_time_lunar_phase_at_or_after/2-example"},{"type":"function","title":"Astro.Lunar.date_time_lunar_phase_at_or_before/2","doc":"Returns the date time of a given\nlunar phase at or before a given\nmoment.","ref":"Astro.Lunar.html#date_time_lunar_phase_at_or_before/2"},{"type":"function","title":"Arguments - Astro.Lunar.date_time_lunar_phase_at_or_before/2","doc":"* a `t:Time.moment()` which is a float number of days\n  since `0000-01-01`\n\n* `phase` is the required lunar phase expressed\n  as a float number of degrees between `0.0` and\n  `360.0`","ref":"Astro.Lunar.html#date_time_lunar_phase_at_or_before/2-arguments"},{"type":"function","title":"Returns - Astro.Lunar.date_time_lunar_phase_at_or_before/2","doc":"* a `t:Time.moment()` which is a float number of days\n  since `0000-01-01`","ref":"Astro.Lunar.html#date_time_lunar_phase_at_or_before/2-returns"},{"type":"function","title":"Example - Astro.Lunar.date_time_lunar_phase_at_or_before/2","doc":"iex> Astro.Lunar.date_time_lunar_phase_at_or_before(738368, Astro.Lunar.new_moon())\n    738346.0524695957","ref":"Astro.Lunar.html#date_time_lunar_phase_at_or_before/2-example"},{"type":"function","title":"Astro.Lunar.date_time_new_moon_at_or_after/1","doc":"Returns the date time of the new\nmoon at or after a given date or\ndate time.","ref":"Astro.Lunar.html#date_time_new_moon_at_or_after/1"},{"type":"function","title":"Arguments - Astro.Lunar.date_time_new_moon_at_or_after/1","doc":"* a `t:Time.moment()` which is a float number of days\n  since `0000-01-01`","ref":"Astro.Lunar.html#date_time_new_moon_at_or_after/1-arguments"},{"type":"function","title":"Returns - Astro.Lunar.date_time_new_moon_at_or_after/1","doc":"* a `t:Time.moment()` which is a float number of days\n  since `0000-01-01`","ref":"Astro.Lunar.html#date_time_new_moon_at_or_after/1-returns"},{"type":"function","title":"Example - Astro.Lunar.date_time_new_moon_at_or_after/1","doc":"iex> Astro.Lunar.date_time_new_moon_at_or_after 738390\n    738405.0352292997","ref":"Astro.Lunar.html#date_time_new_moon_at_or_after/1-example"},{"type":"function","title":"Astro.Lunar.date_time_new_moon_before/1","doc":"Returns the date time of the new\nmoon before a given moment.","ref":"Astro.Lunar.html#date_time_new_moon_before/1"},{"type":"function","title":"Arguments - Astro.Lunar.date_time_new_moon_before/1","doc":"* a `t:Time.moment()` which is a float number of days\n  since `0000-01-01`","ref":"Astro.Lunar.html#date_time_new_moon_before/1-arguments"},{"type":"function","title":"Returns - Astro.Lunar.date_time_new_moon_before/1","doc":"* a `t:Time.moment()` which is a float number of days\n  since `0000-01-01`","ref":"Astro.Lunar.html#date_time_new_moon_before/1-returns"},{"type":"function","title":"Example - Astro.Lunar.date_time_new_moon_before/1","doc":"iex> Astro.Lunar.date_time_new_moon_before 738390\n    738375.5757777032","ref":"Astro.Lunar.html#date_time_new_moon_before/1-example"},{"type":"function","title":"Astro.Lunar.first_quarter/0","doc":"Returns the first quarter lunar\nphase expressed as a float number\nof degrees.","ref":"Astro.Lunar.html#first_quarter/0"},{"type":"function","title":"Astro.Lunar.full_moon/0","doc":"Returns the full moon lunar\nphase expressed as a float number\nof degrees.","ref":"Astro.Lunar.html#full_moon/0"},{"type":"function","title":"Astro.Lunar.illuminated_fraction_of_moon/1","doc":"Returns the fractional illumination of the moon\nat a given time as a fraction between 0.0 and 1.0.","ref":"Astro.Lunar.html#illuminated_fraction_of_moon/1"},{"type":"function","title":"Astro.Lunar.last_quarter/0","doc":"Returns the last quarter lunar\nphase expressed as a float number\nof degrees.","ref":"Astro.Lunar.html#last_quarter/0"},{"type":"function","title":"Astro.Lunar.lunar_altitude/2","doc":"","ref":"Astro.Lunar.html#lunar_altitude/2"},{"type":"function","title":"Astro.Lunar.lunar_distance/1","doc":"","ref":"Astro.Lunar.html#lunar_distance/1"},{"type":"function","title":"Astro.Lunar.lunar_latitude/1","doc":"","ref":"Astro.Lunar.html#lunar_latitude/1"},{"type":"function","title":"Astro.Lunar.lunar_parallax/2","doc":"","ref":"Astro.Lunar.html#lunar_parallax/2"},{"type":"function","title":"Astro.Lunar.lunar_phase_at/1","doc":"Returns the lunar phase as a\nfloat number of degrees at a given\nmoment.","ref":"Astro.Lunar.html#lunar_phase_at/1"},{"type":"function","title":"Arguments - Astro.Lunar.lunar_phase_at/1","doc":"* a `t:Time.moment()` which is a float number of days\n  since `0000-01-01`","ref":"Astro.Lunar.html#lunar_phase_at/1-arguments"},{"type":"function","title":"Returns - Astro.Lunar.lunar_phase_at/1","doc":"* the lunar phase as a float number of\n  degrees.","ref":"Astro.Lunar.html#lunar_phase_at/1-returns"},{"type":"function","title":"Example - Astro.Lunar.lunar_phase_at/1","doc":"iex> Astro.Lunar.lunar_phase_at 738389.5007195644\n    180.00001498208536\n\n    iex> Astro.Lunar.lunar_phase_at 738346.0544609067\n    0.021567106773019873","ref":"Astro.Lunar.html#lunar_phase_at/1-example"},{"type":"function","title":"Astro.Lunar.lunar_position/1","doc":"","ref":"Astro.Lunar.html#lunar_position/1"},{"type":"function","title":"Astro.Lunar.new_moon/0","doc":"Returns the new moon lunar\nphase expressed as a float number\nof degrees.","ref":"Astro.Lunar.html#new_moon/0"},{"type":"function","title":"Astro.Lunar.topocentric_lunar_altitude/2","doc":"","ref":"Astro.Lunar.html#topocentric_lunar_altitude/2"},{"type":"module","title":"Astro.Solar","doc":"Implements sunrise and sunset according to the\nUS NOAA algorithm which is based upon\n[Astronomical Algorithms](https://www.amazon.com/Astronomical-Algorithms-Jean-Meeus/dp/0943396352)\nby Jean Meeus.","ref":"Astro.Solar.html"},{"type":"function","title":"Astro.Solar.earth_orbit_eccentricity/1","doc":"Returns the earth orbit eccentricity.","ref":"Astro.Solar.html#earth_orbit_eccentricity/1"},{"type":"function","title":"Arguments - Astro.Solar.earth_orbit_eccentricity/1","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.","ref":"Astro.Solar.html#earth_orbit_eccentricity/1-arguments"},{"type":"function","title":"Returns - Astro.Solar.earth_orbit_eccentricity/1","doc":"* a unitless value of eccentricity as a `float`.\n  A value of `0` is a circular orbit, values\n  between `0` and `1` form an elliptic orbit,\n  `1` is a parabolic escape orbit, and greater\n  than `1` is a hyperbola.","ref":"Astro.Solar.html#earth_orbit_eccentricity/1-returns"},{"type":"function","title":"Notes - Astro.Solar.earth_orbit_eccentricity/1","doc":"The orbital eccentricity of earth - and any astronomical\nobject - is a dimensionless parameter that determines\nthe amount by which its orbit around another body\ndeviates from a perfect circle. The term derives\nits name from the parameters of conic sections, as\nevery Kepler orbit is a conic section.","ref":"Astro.Solar.html#earth_orbit_eccentricity/1-notes"},{"type":"function","title":"Astro.Solar.equation_of_time/1","doc":"Returns the equation of time in minutes.","ref":"Astro.Solar.html#equation_of_time/1"},{"type":"function","title":"Arguments - Astro.Solar.equation_of_time/1","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.","ref":"Astro.Solar.html#equation_of_time/1-arguments"},{"type":"function","title":"Returns - Astro.Solar.equation_of_time/1","doc":"* The discrepency between apparent time and\n  mean solar time in minutes as a `float`.","ref":"Astro.Solar.html#equation_of_time/1-returns"},{"type":"function","title":"Notes - Astro.Solar.equation_of_time/1","doc":"The equation of time describes the discrepancy between\ntwo kinds of solar time. The word equation is used in\nthe medieval sense of \"reconcile a difference\". The two\ntimes that differ are the apparent solar time, which\ndirectly tracks the diurnal motion of the Sun, and mean\nsolar time, which tracks a theoretical mean Sun with uniform\nmotion. Apparent solar time can be obtained by measurement\nof the current position (hour angle) of the Sun, as\nindicated (with limited accuracy) by a sundial. Mean solar\ntime, for the same place, would be the time indicated by a steady\nclock set so that over the year its differences from apparent\nsolar time would have a mean of zero.\n\nDuring a year the equation of time varies as shown on the\ngraph; its change from one year to the next is slight.\nApparent time, and the sundial, can be ahead (fast) by as\nmuch as 16 min 33 s (around 3 November), or behind (slow) by\nas much as 14 min 6 s (around 11 February). The equation of\ntime has zeros near 15 April, 13 June, 1 September, and\n25 December. Ignoring very slow changes in the Earth's\norbit and rotation, these events are repeated at the same\ntimes every tropical year. However, due to the non-integral\nnumber of days in a year, these dates can vary by a day or\nso from year to year.\n\nThe graph of the equation of time is closely approximated by\nthe sum of two sine curves, one with a period of a year and\none with a period of half a year. The curves reflect two\nastronomical effects, each causing a different non-uniformity\nin the apparent daily motion of the Sun relative to the stars:\n\n* the obliquity of the ecliptic (the plane of the Earth's annual\n  orbital motion around the Sun), which is inclined by about 23.44\n  degrees relative to the plane of the Earth's equator; and\n\n* the eccentricity of the Earth's orbit around the Sun, which is\n  about 0.0167.\n\nThe equation of time is constant only for a planet with zero axial\ntilt and zero orbital eccentricity. On Mars the difference between\nsundial time and clock time can be as much as 50 minutes, due to\nthe considerably greater eccentricity of its orbit. The planet\nUranus, which has an extremely large axial tilt, has an equation\nof time that makes its days start and finish several hours earlier\nor later depending on where it is in its orbit.","ref":"Astro.Solar.html#equation_of_time/1-notes"},{"type":"function","title":"Astro.Solar.equinox_and_solstice/2","doc":"Returns the datetime of an equinox or solstice","ref":"Astro.Solar.html#equinox_and_solstice/2"},{"type":"function","title":"Astro.Solar.estimate_prior_solar_longitude/2","doc":"Return approximate moment at or before tee\nwhen solar longitude just exceeded lambda degrees.","ref":"Astro.Solar.html#estimate_prior_solar_longitude/2"},{"type":"function","title":"Astro.Solar.mean_obliquity_of_ecliptic/1","doc":"Returns the mean obliquity of the ecliptic in degrees.","ref":"Astro.Solar.html#mean_obliquity_of_ecliptic/1"},{"type":"function","title":"Arguments - Astro.Solar.mean_obliquity_of_ecliptic/1","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.","ref":"Astro.Solar.html#mean_obliquity_of_ecliptic/1-arguments"},{"type":"function","title":"Returns - Astro.Solar.mean_obliquity_of_ecliptic/1","doc":"* the mean obliquity of the ecliptic in\n  degrees as a `float`.","ref":"Astro.Solar.html#mean_obliquity_of_ecliptic/1-returns"},{"type":"function","title":"Notes - Astro.Solar.mean_obliquity_of_ecliptic/1","doc":"Obliquity, also known as tilt, is the angle between\nthe rotation access of the earth from the orbital\nplane of the earth around the sun.\n\nEarth's obliquity angle is measured from the imaginary\nline that runs perpendicular to another imaginary line;\nEarth's ecliptic plane or orbital plane\n.\nAt the moment, Earth's obliquity is about 23.4 degrees\nand decreasing. We say 'at the moment' because the\nobliquity changes over time, although very, very slowly.","ref":"Astro.Solar.html#mean_obliquity_of_ecliptic/1-notes"},{"type":"function","title":"Astro.Solar.obliquity_correction/1","doc":"Returns the obliquity correction in degrees.","ref":"Astro.Solar.html#obliquity_correction/1"},{"type":"function","title":"Arguments - Astro.Solar.obliquity_correction/1","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.","ref":"Astro.Solar.html#obliquity_correction/1-arguments"},{"type":"function","title":"Returns - Astro.Solar.obliquity_correction/1","doc":"* the obliquity correction in\n  degrees as a `float`.","ref":"Astro.Solar.html#obliquity_correction/1-returns"},{"type":"function","title":"Astro.Solar.solar_declination/1","doc":"Returns the solar declination in degrees.","ref":"Astro.Solar.html#solar_declination/1"},{"type":"function","title":"Arguments - Astro.Solar.solar_declination/1","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.","ref":"Astro.Solar.html#solar_declination/1-arguments"},{"type":"function","title":"Returns - Astro.Solar.solar_declination/1","doc":"* the solar declination in degrees as\n  a `float`.","ref":"Astro.Solar.html#solar_declination/1-returns"},{"type":"function","title":"Notes - Astro.Solar.solar_declination/1","doc":"The solar declination is the angle between\nthe direction of the center of the solar\ndisk measured from Earth's center and the\nequatorial plane.","ref":"Astro.Solar.html#solar_declination/1-notes"},{"type":"function","title":"Astro.Solar.solar_longitude/1","doc":"Returns the solar longitude in degrees.","ref":"Astro.Solar.html#solar_longitude/1"},{"type":"function","title":"Arguments - Astro.Solar.solar_longitude/1","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.","ref":"Astro.Solar.html#solar_longitude/1-arguments"},{"type":"function","title":"Returns - Astro.Solar.solar_longitude/1","doc":"* the solar longitude in degrees as\n  a `float`.","ref":"Astro.Solar.html#solar_longitude/1-returns"},{"type":"function","title":"Notes - Astro.Solar.solar_longitude/1","doc":"The solar longitude is the position of the sun on the celestial\nsphere along the ecliptic.\n\nIt is also an effective measure of the position of the earth\n(or any other sun-orbiting body) in its orbit around the sun,\nusually taken as zero at the moment of the vernal equinox.\n\nSince it is based on how far the earth has moved in its orbit\nsince the equinox, it is a measure of what time of the tropical\nyear (the year of seasons) the planet is in, but without the\ninaccuracies of a calendar date, which is perturbed by leap years\nand calendar imperfections.","ref":"Astro.Solar.html#solar_longitude/1-notes"},{"type":"function","title":"Astro.Solar.solar_longitude_after/2","doc":"Return the moment UT of the first time at or after moment, tee,\nwhen the solar longitude will be lambda degrees.","ref":"Astro.Solar.html#solar_longitude_after/2"},{"type":"function","title":"Astro.Solar.solar_noon_utc/2","doc":"Returns solar noon as minutes since\nmidnight UTC.","ref":"Astro.Solar.html#solar_noon_utc/2"},{"type":"function","title":"Arguments - Astro.Solar.solar_noon_utc/2","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.\n\n* `longitude` is the longitude in degrees\n  of the location from which solar noon\n  is to be measured.","ref":"Astro.Solar.html#solar_noon_utc/2-arguments"},{"type":"function","title":"Returns - Astro.Solar.solar_noon_utc/2","doc":"* solar noon as a `float` number of\n  minutes since midnight UTC.","ref":"Astro.Solar.html#solar_noon_utc/2-returns"},{"type":"function","title":"Notes - Astro.Solar.solar_noon_utc/2","doc":"Solar noon is the moment when the Sun passes a\nlocation's meridian and reaches its highest position\nin the sky. In most cases, it doesn't happen at 12 o'clock.\n\nAt solar noon, the Sun reaches its\nhighest position in the sky as it passes the\nlocal meridian.","ref":"Astro.Solar.html#solar_noon_utc/2-notes"},{"type":"function","title":"Astro.Solar.sun_apparent_longitude/1","doc":"Returns the suns apparent longitude in degrees.","ref":"Astro.Solar.html#sun_apparent_longitude/1"},{"type":"function","title":"Arguments - Astro.Solar.sun_apparent_longitude/1","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.","ref":"Astro.Solar.html#sun_apparent_longitude/1-arguments"},{"type":"function","title":"Returns - Astro.Solar.sun_apparent_longitude/1","doc":"* equation of the center in degrees\n  as a `float`.","ref":"Astro.Solar.html#sun_apparent_longitude/1-returns"},{"type":"function","title":"Notes - Astro.Solar.sun_apparent_longitude/1","doc":"The apparent longitude is the sun's celestial\nlongitude corrected for aberration and nutation\nas opposed to mean longitude.\n\nAn equinox is the instant when the Sun's\napparent geocentric longitude is 0° (northward\nequinox) or 180° (southward equinox).","ref":"Astro.Solar.html#sun_apparent_longitude/1-notes"},{"type":"function","title":"Astro.Solar.sun_equation_of_center/1","doc":"Return the sun's equation of the center in degrees.","ref":"Astro.Solar.html#sun_equation_of_center/1"},{"type":"function","title":"Arguments - Astro.Solar.sun_equation_of_center/1","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.","ref":"Astro.Solar.html#sun_equation_of_center/1-arguments"},{"type":"function","title":"Returns - Astro.Solar.sun_equation_of_center/1","doc":"* equation of the center in degrees\n  as a `float`.","ref":"Astro.Solar.html#sun_equation_of_center/1-returns"},{"type":"function","title":"Notes - Astro.Solar.sun_equation_of_center/1","doc":"In two-body, Keplerian orbital mechanics, the equation\nof the center is the angular difference between the\nactual position of a body in its elliptical orbit and\nthe position it would occupy if its motion were uniform,\nin a circular orbit of the same period.\n\nIt is defined as the difference true anomaly, ν,\nminus mean anomaly, M, and is typically expressed a\nfunction of mean anomaly, M, and orbital eccentricity, e.","ref":"Astro.Solar.html#sun_equation_of_center/1-notes"},{"type":"function","title":"Astro.Solar.sun_geometric_mean_anomaly/1","doc":"Returns the suns geometric mean anomoly in degrees.","ref":"Astro.Solar.html#sun_geometric_mean_anomaly/1"},{"type":"function","title":"Arguments - Astro.Solar.sun_geometric_mean_anomaly/1","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.","ref":"Astro.Solar.html#sun_geometric_mean_anomaly/1-arguments"},{"type":"function","title":"Returns - Astro.Solar.sun_geometric_mean_anomaly/1","doc":"* the mean anomoly in degrees as a `float`","ref":"Astro.Solar.html#sun_geometric_mean_anomaly/1-returns"},{"type":"function","title":"Notes - Astro.Solar.sun_geometric_mean_anomaly/1","doc":"In celestial mechanics, the mean anomaly is the\nfraction of an elliptical orbit's period that has\nelapsed since the orbiting body passed periapsis,\nexpressed as an angle which can be used in calculating\nthe position of that body in the classical two-body\nproblem.\n\nIt is the angular distance from the pericenter\nwhich a fictitious body would have if it moved\nin a circular orbit, with constant speed, in the same\norbital period as the actual body in its elliptical orbit.","ref":"Astro.Solar.html#sun_geometric_mean_anomaly/1-notes"},{"type":"function","title":"Astro.Solar.sun_geometric_mean_longitude/1","doc":"Returns the sun's geometric mean longitude in degrees.","ref":"Astro.Solar.html#sun_geometric_mean_longitude/1"},{"type":"function","title":"Arguments - Astro.Solar.sun_geometric_mean_longitude/1","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.","ref":"Astro.Solar.html#sun_geometric_mean_longitude/1-arguments"},{"type":"function","title":"Returns - Astro.Solar.sun_geometric_mean_longitude/1","doc":"* the mean solar longitude in degrees as a float.","ref":"Astro.Solar.html#sun_geometric_mean_longitude/1-returns"},{"type":"function","title":"Notes - Astro.Solar.sun_geometric_mean_longitude/1","doc":"Mean longitude, like mean anomaly, does not measure\nan angle between any physical objects. It is simply\na convenient uniform measure of how far around its orbit\na body has progressed since passing the reference\ndirection. While mean longitude measures a mean position\nand assumes constant speed, true longitude measures the\nactual longitude and assumes the body has moved with its\nactual speed, which varies around its elliptical orbit.\n\nThe difference between the two is known as the equation\nof the center.","ref":"Astro.Solar.html#sun_geometric_mean_longitude/1-notes"},{"type":"function","title":"Astro.Solar.sun_true_longitude/1","doc":"Returns the suns true longitude in degrees.","ref":"Astro.Solar.html#sun_true_longitude/1"},{"type":"function","title":"Arguments - Astro.Solar.sun_true_longitude/1","doc":"* `julian_centuries` is the any moment\n  in time expressed as julian centuries.","ref":"Astro.Solar.html#sun_true_longitude/1-arguments"},{"type":"function","title":"Returns - Astro.Solar.sun_true_longitude/1","doc":"* the suns true longitude in degrees\n  as a `float`.","ref":"Astro.Solar.html#sun_true_longitude/1-returns"},{"type":"function","title":"Notes - Astro.Solar.sun_true_longitude/1","doc":"In celestial mechanics true longitude is the\necliptic longitude at which an orbiting body\ncould actually be found if its inclination\nwere zero.\n\nTogether with the inclination and the ascending\nnode, the true longitude can tell us the precise\ndirection from the central object at which the\nbody would be located at a particular time.","ref":"Astro.Solar.html#sun_true_longitude/1-notes"},{"type":"function","title":"Astro.Solar.utc_sun_position/4","doc":"Returns the UTC time of sun's position\nfor a given location as a float time-of-day.","ref":"Astro.Solar.html#utc_sun_position/4"},{"type":"function","title":"Arguments - Astro.Solar.utc_sun_position/4","doc":"* `date` is a `DateTime.t()` in the UTC\n  time zone.\n\n* `location` is any `t:Geo.PointZ.t/0`\n  location.\n\n* `solar_elevation` is the required solar\n  elevation in degrees (90 degrees for sunrise\n  and sunset).\n\n* `mode` is `:sunrise` or `:sunset`.","ref":"Astro.Solar.html#utc_sun_position/4-arguments"},{"type":"function","title":"Returns - Astro.Solar.utc_sun_position/4","doc":"* `{:ok, moment}` where `moment` is float\n  representing the number of hours after\n  midnight for sunrise or sunset or\n\n* `{:error, :no_time}` if there is no\n  sunrise/sunset for the given date at the\n  given location. This can occur for very\n  high latitudes in winter and summer.","ref":"Astro.Solar.html#utc_sun_position/4-returns"},{"type":"function","title":"Notes - Astro.Solar.utc_sun_position/4","doc":"This implementation is based on equations from\n[Astronomical Algorithms](https://www.amazon.com/astronomical-algorithms-jean-meeus/dp/0943396611),\nby Jean Meeus. The sunrise and sunset results are\ntheoretically accurate to within a minute for\nlocations between +/- 72° latitude, and within\n10 minutes outside of those latitudes. However, due to\nvariations in atmospheric composition, temperature,\npressure and conditions, observed values may vary from\ncalculations.","ref":"Astro.Solar.html#utc_sun_position/4-notes"},{"type":"module","title":"Astro.Supervisor","doc":"Provides a supervision tree under which\nthe required TzWorld backend server can\nbe started.","ref":"Astro.Supervisor.html"},{"type":"function","title":"Astro.Supervisor.start/2","doc":"Starts a TzWorld backend module that\nmanages the time zone data required for\nAstro to operate.\n\nThe backend process is started under a\nsupervisor called Astro.Supervisor.","ref":"Astro.Supervisor.html#start/2"},{"type":"module","title":"Astro.Time","doc":"Calculations converting between geometry and time\n\nAll public functions use degrees as their input\nparameters\n\nTime is a fraction of a day after UTC","ref":"Astro.Time.html"},{"type":"function","title":"Astro.Time.ajd/1","doc":"","ref":"Astro.Time.html#ajd/1"},{"type":"function","title":"Astro.Time.datetime_from_date_and_minutes/2","doc":"Adds the requested minutes to a date\nreturning a datetime in the UTC time zone","ref":"Astro.Time.html#datetime_from_date_and_minutes/2"},{"type":"function","title":"Arguments - Astro.Time.datetime_from_date_and_minutes/2","doc":"* `minutes` is a float number of minutes since midnight\n\n* `date` is any date in the Gregorian calendar","ref":"Astro.Time.html#datetime_from_date_and_minutes/2-arguments"},{"type":"function","title":"Returns - Astro.Time.datetime_from_date_and_minutes/2","doc":"* `{:ok, datetime in the UTC time zone}`","ref":"Astro.Time.html#datetime_from_date_and_minutes/2-returns"},{"type":"function","title":"Astro.Time.datetime_from_julian_days/1","doc":"Returns the datetime for a given Julian day","ref":"Astro.Time.html#datetime_from_julian_days/1"},{"type":"function","title":"Arguments - Astro.Time.datetime_from_julian_days/1","doc":"* `julian_day` is any astronomical Julian day such\n  as returned from `Astro.Time.julian_day_from_date/1`","ref":"Astro.Time.html#datetime_from_julian_days/1-arguments"},{"type":"function","title":"Returns - Astro.Time.datetime_from_julian_days/1","doc":"* a `DateTime.t` in the UTC time zone","ref":"Astro.Time.html#datetime_from_julian_days/1-returns"},{"type":"function","title":"Example - Astro.Time.datetime_from_julian_days/1","doc":"iex> Astro.Time.datetime_from_julian_days 2458822.5\n    {:ok, ~U[2019-12-05 00:00:00Z]}","ref":"Astro.Time.html#datetime_from_julian_days/1-example"},{"type":"function","title":"Astro.Time.dynamical_from_universal/1","doc":"Returns the dynamical time for a given\nuniversal time.\n\nDynamical time is the time-scale that is used in\ncalculating orbital motions within the Solar\nSystem. The underlying physical law governing\nsuch motions is the law of gravitation.","ref":"Astro.Time.html#dynamical_from_universal/1"},{"type":"function","title":"Astro.Time.ephemeris_correction/1","doc":"Returns the adjustment necessary to various celestial\ncalculations at a given time.\n\nThe ajustment is required since the earth's orbit\nof the sun is not completely uniform.","ref":"Astro.Time.html#ephemeris_correction/1"},{"type":"function","title":"Astro.Time.greenwich_mean_sidereal_time/1","doc":"Returns the Greenwich mean sidereal time for a given date time.","ref":"Astro.Time.html#greenwich_mean_sidereal_time/1"},{"type":"function","title":"Astro.Time.hours_to_days/1","doc":"Converts a number of hours into days.","ref":"Astro.Time.html#hours_to_days/1"},{"type":"function","title":"Arguments - Astro.Time.hours_to_days/1","doc":"* a float number of `hours`","ref":"Astro.Time.html#hours_to_days/1-arguments"},{"type":"function","title":"Returns - Astro.Time.hours_to_days/1","doc":"* a float number of `days`","ref":"Astro.Time.html#hours_to_days/1-returns"},{"type":"function","title":"Examples - Astro.Time.hours_to_days/1","doc":"iex> Astro.Time.hours_to_days(48)\n    2.0","ref":"Astro.Time.html#hours_to_days/1-examples"},{"type":"function","title":"Astro.Time.hours_to_hms/1","doc":"Converts a float number of hours\nsince midnight into `{hours, minutes, seconds}`.","ref":"Astro.Time.html#hours_to_hms/1"},{"type":"function","title":"Arguments - Astro.Time.hours_to_hms/1","doc":"* `time_of_day` is a float number of hours\n  since midnight","ref":"Astro.Time.html#hours_to_hms/1-arguments"},{"type":"function","title":"Returns - Astro.Time.hours_to_hms/1","doc":"* A `{hour, minute, second}` tuple. Fractions of\n  seconds are truncated.","ref":"Astro.Time.html#hours_to_hms/1-returns"},{"type":"function","title":"Examples - Astro.Time.hours_to_hms/1","doc":"iex> Astro.Time.hours_to_hms 0.0\n  {0, 0, 0}\n\n  iex> Astro.Time.hours_to_hms 23.999\n  {23, 59, 56}\n\n  iex> Astro.Time.hours_to_hms 15.456\n  {15, 27, 21}","ref":"Astro.Time.html#hours_to_hms/1-examples"},{"type":"function","title":"Astro.Time.j2000/0","doc":"Returns the day number for\nJanuary 1st, 2000","ref":"Astro.Time.html#j2000/0"},{"type":"function","title":"Astro.Time.julian_centuries_from_julian_day/1","doc":"Returns the Julian centuries for a given\nJulian day","ref":"Astro.Time.html#julian_centuries_from_julian_day/1"},{"type":"function","title":"Arguments - Astro.Time.julian_centuries_from_julian_day/1","doc":"* `julian_day` is any astronomical Julian day such\n  as returned from `Astro.Time.julian_day_from_date/1`","ref":"Astro.Time.html#julian_centuries_from_julian_day/1-arguments"},{"type":"function","title":"Returns - Astro.Time.julian_centuries_from_julian_day/1","doc":"* the astronomical Julian century as a `float`","ref":"Astro.Time.html#julian_centuries_from_julian_day/1-returns"},{"type":"function","title":"Astro.Time.julian_centuries_from_moment/1","doc":"","ref":"Astro.Time.html#julian_centuries_from_moment/1"},{"type":"function","title":"Astro.Time.julian_day_from_date/1","doc":"Returns the astronomical Julian day for a given\ndate","ref":"Astro.Time.html#julian_day_from_date/1"},{"type":"function","title":"Arguments - Astro.Time.julian_day_from_date/1","doc":"* `date` is any `Calendar.date`","ref":"Astro.Time.html#julian_day_from_date/1-arguments"},{"type":"function","title":"Returns - Astro.Time.julian_day_from_date/1","doc":"* the astronomical Julian day as a `float`","ref":"Astro.Time.html#julian_day_from_date/1-returns"},{"type":"function","title":"Example - Astro.Time.julian_day_from_date/1","doc":"iex> Astro.Time.julian_day_from_date ~D[2019-12-05]\n  2458822.5","ref":"Astro.Time.html#julian_day_from_date/1-example"},{"type":"function","title":"Astro.Time.julian_day_from_julian_centuries/1","doc":"Returns the Julian day for a given\nJulian century","ref":"Astro.Time.html#julian_day_from_julian_centuries/1"},{"type":"function","title":"Arguments - Astro.Time.julian_day_from_julian_centuries/1","doc":"* `julian_century` is any astronomical Julian century such\n  as returned from `Astro.Time.julian_centuries_from_julian_day/1`","ref":"Astro.Time.html#julian_day_from_julian_centuries/1-arguments"},{"type":"function","title":"Returns - Astro.Time.julian_day_from_julian_centuries/1","doc":"* the astronomical Julian day as a `float`","ref":"Astro.Time.html#julian_day_from_julian_centuries/1-returns"},{"type":"function","title":"Astro.Time.local_from_universal/2","doc":"Returns the local time from the\nuniversal time at a given location.\n\nLocale time is UTC time plus the number\nof hours offset calculated from the longitude\nof a location.\n\nThis is different to standard time which\nis UTC time adjusted for a specific time\nzone name.","ref":"Astro.Time.html#local_from_universal/2"},{"type":"function","title":"Astro.Time.local_sidereal_time/2","doc":"Returns the local sidereal time for a given location\nand date time.","ref":"Astro.Time.html#local_sidereal_time/2"},{"type":"function","title":"Astro.Time.mjd/1","doc":"Returns the modified Julian day for a date","ref":"Astro.Time.html#mjd/1"},{"type":"function","title":"Arguments - Astro.Time.mjd/1","doc":"* `date` is any `Calendar.date`","ref":"Astro.Time.html#mjd/1-arguments"},{"type":"function","title":"Returns - Astro.Time.mjd/1","doc":"* the modified Julian day as a `float`","ref":"Astro.Time.html#mjd/1-returns"},{"type":"function","title":"Notes - Astro.Time.mjd/1","doc":"A modified version of the Julian date denoted MJD is\nobtained by subtracting 2,400,000.5 days from the\nJulian date JD,\n\nThe MJD therefore gives the number of days since\nmidnight on November 17, 1858. This date corresponds\nto `2400000.5` days after day 0 of the Julian calendar.","ref":"Astro.Time.html#mjd/1-notes"},{"type":"function","title":"Astro.Time.moment_to_datetime/2","doc":"Converts a float number of hours since midnight to\na `DateTime.t()`","ref":"Astro.Time.html#moment_to_datetime/2"},{"type":"function","title":"Arguments - Astro.Time.moment_to_datetime/2","doc":"* `time_of_day` is a float number of hours\n  since midnight\n\n* `date` is any `Calendar.date()`","ref":"Astro.Time.html#moment_to_datetime/2-arguments"},{"type":"function","title":"Returns - Astro.Time.moment_to_datetime/2","doc":"A `DateTime.t()` combining the `date` and `time_of_day`\nin the UTC timezone.","ref":"Astro.Time.html#moment_to_datetime/2-returns"},{"type":"function","title":"Astro.Time.offset_for_zone/3","doc":"Returns the offset in float days\nfor a given number of gregorian seconds and time zone.","ref":"Astro.Time.html#offset_for_zone/3"},{"type":"function","title":"Example - Astro.Time.offset_for_zone/3","doc":"iex> t = Date.to_gregorian_days(~D[2021-08-01]) * (60 * 60 * 24)\n    iex> Astro.Time.offset_for_zone t, \"Europe/London\"\n    0.041666666666666664","ref":"Astro.Time.html#offset_for_zone/3-example"},{"type":"function","title":"Astro.Time.offset_from_longitude/1","doc":"Returns the zone difference in hours between\na given location and UTC.","ref":"Astro.Time.html#offset_from_longitude/1"},{"type":"function","title":"Astro.Time.periods_for_time/3","doc":"","ref":"Astro.Time.html#periods_for_time/3"},{"type":"function","title":"Astro.Time.seconds_to_hms/1","doc":"Converts a number of seconds\nsince midnight into `{hours, minutes, seconds}`.","ref":"Astro.Time.html#seconds_to_hms/1"},{"type":"function","title":"Arguments - Astro.Time.seconds_to_hms/1","doc":"* `time_of_day` is a number of seconds","ref":"Astro.Time.html#seconds_to_hms/1-arguments"},{"type":"function","title":"Returns - Astro.Time.seconds_to_hms/1","doc":"* A `{hour, minute, second}` tuple.","ref":"Astro.Time.html#seconds_to_hms/1-returns"},{"type":"function","title":"Examples - Astro.Time.seconds_to_hms/1","doc":"iex> Astro.Time.seconds_to_hms 0.0\n  {0, 0, 0}\n\n  iex> Astro.Time.seconds_to_hms 3214\n  {0, 53, 34}\n\n  iex> Astro.Time.seconds_to_hms 10_000\n  {2, 46, 39}","ref":"Astro.Time.html#seconds_to_hms/1-examples"},{"type":"function","title":"Astro.Time.sidereal_from_moment/1","doc":"","ref":"Astro.Time.html#sidereal_from_moment/1"},{"type":"function","title":"Astro.Time.standard_from_universal/2","doc":"Returns the standard time for a universal time in a given\ntime zone.","ref":"Astro.Time.html#standard_from_universal/2"},{"type":"function","title":"Astro.Time.universal_from_dynamical/1","doc":"Returns the universal (UTC) time\nfor a given dynamical time.\n\nCoordinated Universal Time or UTC is\nthe primary time standard by which the\nworld regulates clocks and time.\n\nIt is within about 1 second of mean solar\ntime at 0° longitude and is not adjusted\nfor daylight saving time.\n\nIt is effectively a successor to Greenwich\nMean Time (GMT).","ref":"Astro.Time.html#universal_from_dynamical/1"},{"type":"function","title":"Astro.Time.universal_from_local/2","doc":"Returns the universal time (UTC) from\nthe local time at a given location.\n\nLocale time is UTC time plus the number\nof hours offset calculated from the longitude\nof a location.\n\nThis is different to standard time which\nis UTC time adjusted for a specific time\nzone name.","ref":"Astro.Time.html#universal_from_local/2"},{"type":"function","title":"Astro.Time.universal_from_standard/2","doc":"Returns the universal (UTC) time for a standard time in a given time\nzone.","ref":"Astro.Time.html#universal_from_standard/2"},{"type":"function","title":"Astro.Time.utc_datetime_from_terrestrial_datetime/1","doc":"Converts a terrestrial datetime to a UTC datetime","ref":"Astro.Time.html#utc_datetime_from_terrestrial_datetime/1"},{"type":"function","title":"Arguments - Astro.Time.utc_datetime_from_terrestrial_datetime/1","doc":"* `datetime` is any UTC datetime which is considered\n  to be a Terrestrial Time.","ref":"Astro.Time.html#utc_datetime_from_terrestrial_datetime/1-arguments"},{"type":"function","title":"Returns - Astro.Time.utc_datetime_from_terrestrial_datetime/1","doc":"* A UTC datetime adjusted for the difference\n  between Terrestrial Time and UTC time","ref":"Astro.Time.html#utc_datetime_from_terrestrial_datetime/1-returns"},{"type":"function","title":"Notes - Astro.Time.utc_datetime_from_terrestrial_datetime/1","doc":"Terrestrial Time (TT) was introduced by the IAU in 1979 as\nthe coordinate time scale for an observer on the\nsurface of Earth. It takes into account relativistic\neffects and is based on International Atomic Time (TAI),\nwhich is a high-precision standard using several hundred\natomic clocks worldwide. As such, TD is the atomic time\nequivalent to its predecessor Ephemeris Time (ET) and is\nused in the theories of motion for bodies in the solar\nsystem.\n\nTo ensure continuity with ET, TD was defined to match\nET for the date 1977 Jan 01. In 1991, the IAU refined\nthe definition of TT to make it more precise. It was\nalso renamed Terrestrial Time (TT) from the earlier\nTerrestrial Dynamical Time (TDT).","ref":"Astro.Time.html#utc_datetime_from_terrestrial_datetime/1-notes"},{"type":"type","title":"Astro.Time.days/0","doc":"A number of days as a float","ref":"Astro.Time.html#t:days/0"},{"type":"type","title":"Astro.Time.fraction_of_day/0","doc":"A time of day as a float fraction of a day","ref":"Astro.Time.html#t:fraction_of_day/0"},{"type":"type","title":"Astro.Time.hms/0","doc":"A tuple of integer hours, integer minutes and integer seconds","ref":"Astro.Time.html#t:hms/0"},{"type":"type","title":"Astro.Time.hours/0","doc":"A number of hours as a float","ref":"Astro.Time.html#t:hours/0"},{"type":"type","title":"Astro.Time.julian_centuries/0","doc":"The float number of Julian centuries.\n\nSince there are 365.25 days in a Julian year,\na Julian century has 36,525 days.","ref":"Astro.Time.html#t:julian_centuries/0"},{"type":"type","title":"Astro.Time.julian_days/0","doc":"A float number of days since the Julian epoch.\n\nThe current Julian epoch is defined to have been\nnoon on January 1, 2000. This epoch is\ndenoted J2000 and has the exact Julian day\nnumber `2,451,545.0`.","ref":"Astro.Time.html#t:julian_days/0"},{"type":"type","title":"Astro.Time.minutes/0","doc":"A number of minutes as a float","ref":"Astro.Time.html#t:minutes/0"},{"type":"type","title":"Astro.Time.moment/0","doc":"A moment is a floating point representation of\nthe fraction of a day.","ref":"Astro.Time.html#t:moment/0"},{"type":"type","title":"Astro.Time.season/0","doc":"Season expressed as a non-negative number\nthat is <= 360 representing the sun angle of incidence\n(the angle at which the sun hits the earth).","ref":"Astro.Time.html#t:season/0"},{"type":"type","title":"Astro.Time.seconds/0","doc":"A number of seconds as a float","ref":"Astro.Time.html#t:seconds/0"},{"type":"type","title":"Astro.Time.time/0","doc":"A time is a floating point number of\ndays since 0000-01-01 including the fractional\npart of a day.","ref":"Astro.Time.html#t:time/0"},{"type":"type","title":"Astro.Time.zone_name/0","doc":"A time zone name as a string","ref":"Astro.Time.html#t:zone_name/0"},{"type":"extras","title":"Astro","doc":"# Astro\n\n[![Hex.pm](https://img.shields.io/hexpm/v/astro.svg)](https://hex.pm/packages/astro)\n[![Hex.pm](https://img.shields.io/hexpm/dw/astro.svg?)](https://hex.pm/packages/astro)\n[![Hex.pm](https://img.shields.io/hexpm/dt/astro.svg?)](https://hex.pm/packages/astro)\n[![Hex.pm](https://img.shields.io/hexpm/l/astro.svg)](https://hex.pm/packages/astro)\n\nAstro is a library to provide basic astromonomical functions with a focus on functions that support solar, lunar and lunisolar calendars such as the Chinese, Hebrew and Persian calendars.","ref":"readme.html"},{"type":"extras","title":"Usage - Astro","doc":"**NOTE: It's important to install and configure `Astro` correctly before use. See the [installation](#installation) notes below.**\n\nThe primary functions are:","ref":"readme.html#usage"},{"type":"extras","title":"Solar function - Astro","doc":"* `Astro.sunrise/3`\n* `Astro.sunset/3`\n* `Astro.solstice/2`\n* `Astro.equinox/2`\n* `Astro.hours_of_daylight/2`","ref":"readme.html#solar-function"},{"type":"extras","title":"Lunar functions - Astro","doc":"* `Astro.moon_position_at/1`\n* `Astro.illuminated_fraction_of_moon_at/1`\n* `Astro.date_time_new_moon_at_or_after/1`\n* `Astro.lunar_phase_at/1`\n* `Astro.lunar_phase_emoji/1`","ref":"readme.html#lunar-functions"},{"type":"extras","title":"Examples - Astro","doc":"```elixir\n  # Sunrise in Sydney on December 4th\n  iex> Astro.sunrise({151.20666584, -33.8559799094}, ~D[2019-12-04])\n  {:ok, #DateTime<2019-12-04 05:37:00.000000+11:00 AEDT Australia/Sydney>}\n\n  # Sunset in Sydney on December 4th\n  iex> Astro.sunset({151.20666584, -33.8559799094}, ~D[2019-12-04])\n  {:ok, #DateTime<2019-12-04 19:53:00.000000+11:00 AEDT Australia/Sydney>}\n\n  # Sunset in the town of Alert in Nunavut, Canada\n  # ...doesn't exist since there is no sunset in summer\n  iex> Astro.sunset({-62.3481, 82.5018}, ~D[2019-07-01])\n  {:error, :no_time}\n\n  # ...or sunrise in winter\n  iex> Astro.sunrise({-62.3481, 82.5018}, ~D[2019-12-04])\n  {:error, :no_time}\n\n  # Hours of daylight on December 7th in Sydney\n  iex> Astro.hours_of_daylight {151.20666584, -33.8559799094}, ~D[2019-12-07]\n  {:ok, ~T[14:18:45]}\n\n  # No sunset in summer at high latitudes\n  iex> Astro.hours_of_daylight {-62.3481, 82.5018}, ~D[2019-06-07]\n  {:ok, ~T[23:59:59]}\n\n  # No sunrise in winter at high latitudes\n  iex> Astro.hours_of_daylight {-62.3481, 82.5018}, ~D[2019-12-07]\n  {:ok, ~T[00:00:00]}\n\n  # Calculate solstices for 2019\n  iex> Astro.solstice 2019, :december\n  {:ok, ~U[2019-12-22 04:18:57Z]}\n\n  iex> Astro.solstice 2019, :june\n  {:ok, ~U[2019-06-21 15:53:45Z]}\n\n  # Calculate equinoxes for 2019\n  iex> Astro.equinox 2019, :march\n  {:ok, ~U[2019-03-20 21:58:06Z]}\n\n  iex> Astro.equinox 2019, :september\n  {:ok, ~U[2019-09-23 07:49:30Z]}\n```","ref":"readme.html#examples"},{"type":"extras","title":"Specifying a location - Astro","doc":"The desired location of sunrise or sunset can be specified as either:\n\n* a tuple of longitude and latitude (note the order) such as `{-62.3481, 82.5018}`\n* a tuple of longitude, latitude and elevation (note the order) such as `{-62.3481, 82.5018, 0}`.\n* a `Geo.Point.t` struct\n* a `Geo.PointZ.t` struct","ref":"readme.html#specifying-a-location"},{"type":"extras","title":"Location units and direction - Astro","doc":"For this implementation, the latitude and longitude of the functions in `Astro` are specified as follows:\n\n* Longitude is `+` for eastern longitudes and `-` for western longitudes and specified in degrees\n* Latitude is `+` for northern latitudes and `-` for southern latitudes and specified in degrees\n* Elevation is specified in meters","ref":"readme.html#location-units-and-direction"},{"type":"extras","title":"References - Astro","doc":"* Thanks to @pinnymz for the [ruby-zmanim](https://github.com/pinnymz/ruby-zmanim) gem which has a well structured ruby implementation of sunrise / sunset and some core astronomical algorithms.\n\n* Eventually all roads lead to the canonical book on the subject by Jean Meeus: [Astronomical Algorithms](https://www.amazon.com/Astronomical-Algorithms-Jean-Meeus/dp/0943396352)\n\n* For the intersection of calendars and astronomy, [Calendrical Calculations](https://www.amazon.com/Calendrical-Calculations-Ultimate-Edward-Reingold/dp/1107683165) by Nachum Dershowitz and Edward M. Reingold remains the standard reference.\n\n* On the web, [timeanddate.com](https://www.timeanddate.com/astronomy/) is a great reference. The sunrise/sunset calculations in this library are tested to return times within 1 minute of timeanddate.com results.\n\n* [Wikipedia](https://wikipedia.com) for content to help describe the understanding behind some of the functions","ref":"readme.html#references"},{"type":"extras","title":"Installation - Astro","doc":"","ref":"readme.html#installation"},{"type":"extras","title":"Configure Astro - Astro","doc":"Astro can be installed by adding `astro` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:astro, \"~> 1.0\"}\n  ]\nend\n```","ref":"readme.html#configure-astro"},{"type":"extras","title":"Install a time zone database - Astro","doc":"A time zone database is required in order to support time zone conversions. Two popular options are [tzdata](https://hex.pm/packages/tzdata) and [tz](https://hex.pm/packages/tz). Then the appropriate database must be configured in `config.exs` or `runtime.exs` as the default time zone database.  For example:\n\n```elixir\n# If using tzdata\nconfig :elixir,\n  :time_zone_database, Tzdata.TimeZoneDatabase\n  \n# If using tz\nconfig :elixir, \n  :time_zone_database, Tz.TimeZoneDatabase\n```","ref":"readme.html#install-a-time-zone-database"},{"type":"extras","title":"Install TzWorld Data - Astro","doc":"Then get dependencies and install the data required to determine a time zone from a location which is used by the dependency `tz_world`.\n\n```\nmix deps.get\nmix tz_world.update\n```","ref":"readme.html#install-tzworld-data"},{"type":"extras","title":"Add TzWorld to supervision tree - Astro","doc":"It is also required that `tz_world` be added to your applications supervision tree by adding the relevant `tz_world` backend to it in your `MyApp.Application` module:\n```\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      .....\n      # See the documentation for tz_world for the\n      # various available backends. This is the recommended\n      # backend.\n      TzWorld.Backend.DetsWithIndexCache\n    ]\n\n    opts = [strategy: :one_for_one, name: Astro.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```","ref":"readme.html#add-tzworld-to-supervision-tree"},{"type":"extras","title":"Configure your application module - Astro","doc":"Make sure that you have configured your application in `mix.exs`:\n```elixir\n  def application do\n    [\n      mod: {MyApp.Application, [strategy: :one_for_one]},\n      .....\n    ]\n  end\n```\n\nDocumentation can be found at [https://hexdocs.pm/astro](https://hexdocs.pm/astro).","ref":"readme.html#configure-your-application-module"},{"type":"extras","title":"License","doc":"# License\n\nCopyright 2018-2019 Kip Cole\n\nLicensed under the Apache License, Version 2.0 (the \"License\"); you may not use this file except in\ncompliance with the License. You may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software distributed under the License\nis distributed on an \"AS IS\" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\nimplied. See the License for the specific language governing permissions and limitations under the\nLicense.","ref":"license.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"Astro version 1.0.2 - Changelog","doc":"This is the changelog for Astro version 1.0.2 released on ay 27th, 2024.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)","ref":"changelog.html#astro-version-1-0-2"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix sunrise/sunset calculations when the solar elevation isn't 90 degrees. Thanks to @cloud8421 for the issue. Closes #5.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Astro version 1.0.1 - Changelog","doc":"This is the changelog for Astro version 1.0.1 released on April 6th, 2024.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)","ref":"changelog.html#astro-version-1-0-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Use only the configured time zone database to resolve time zone information. Therefore any module that implements the `Calendar.TimeZoneDatabase` behaviour can be used. This also makes the code align with the README so that either `Tzdata` or `Tz` can be configured as the systems time zone database (or any future library).  Thanks to @ericlathrop for the issue. Closes #4.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Astro version 1.0.0 - Changelog","doc":"This is the changelog for Astro version 1.0.0 released on December 29th, 2022.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)","ref":"changelog.html#astro-version-1-0-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Release 1.0.  This library was started four years ago and the public API has been stable for at least three of those years.\n\n* Adds `Astro.sun_azimuth_altitude/2`. Thanks to @kimlai for the suggestion. Closes #3.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Astro version 0.10.0 - Changelog","doc":"This is the changelog for Astro version 0.10.0 released on November 7th, 2022.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)","ref":"changelog.html#astro-version-0-10-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds `Astro.Math.floor/1` and `Astro.Math.ceil/1` which are needed to support `Tempo`.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Astro version 0.9.2 - Changelog","doc":"This is the changelog for Astro version 0.9.2 released on September 1st, 2022.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)","ref":"changelog.html#astro-version-0-9-2"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Update `:tz_world` to \"~> 1.0\" which will also remove Elixir 1.14 warnings","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Astro version 0.9.1 - Changelog","doc":"This is the changelog for Astro version 0.9.1 released on October 23rd, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)","ref":"changelog.html#astro-version-0-9-1"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Ensure that `gregorian_seconds` is an integer before passing it to `Tzdata.periods_for_time/3`. Thanks to @dvic for the report. Fixes #2.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Astro version 0.9.0 - Changelog","doc":"This is the changelog for Astro version 0.9.0 released on October 8th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)\n\n**Please note that Elixir 1.11 or later is required.**","ref":"changelog.html#astro-version-0-9-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Adds `Astro.lunar_phase_emoji/1` to produce a single grapheme string representing the image of the moon phase for a given lunar angle.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Astro version 0.8.0 - Changelog","doc":"This is the changelog for Astro version 0.8.0 released on October 3rd, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)\n\n**Please note that Elixir 1.11 or later is required.**","ref":"changelog.html#astro-version-0-8-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Convert some identity functions to macros which improves runtime performance\n\n* Add additional specs and docs to `Astro.Math` module","ref":"changelog.html#enhancements"},{"type":"extras","title":"Astro version 0.7.0 - Changelog","doc":"This is the changelog for Astro version 0.7.0 released on September 10th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)\n\n**Please note that Elixir 1.11 or later is required.**","ref":"changelog.html#astro-version-0-7-0"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Revert `Astro` back to a pure library application. The supervisor for `TzWorld` still needs to be started. This fix brings the code back into line with the [README](/readme.html). Thanks to @dvic for the report. Closes #1.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Astro version 0.6.0 - Changelog","doc":"This is the changelog for Astro version 0.6.0 released on September 5th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)\n\n**Please note that Elixir 1.11 or later is required.**","ref":"changelog.html#astro-version-0-6-0"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Fix `Astro.Math.atan_r/2`\n\n* Fix ephemeris calculation","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Breaking changes - Changelog","doc":"* Change `Time.date_time_{from, to}_iso_days/1` to `Time.date_time_{from, to}_moment/1`","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Remove dependency on `ex_cldr_calendar` and `jason`\n\n* Add `Astro.sun_position_at/1`\n\n* Add `Astro.moon_position_at/1`\n\n* Add `Astro.illuminated_fraction_of_moon_at/1`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Astro version 0.5.0 - Changelog","doc":"This is the changelog for Astro version 0.5.0 released on August 26th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)\n\n**Please note that Elixir 1.11 or later is required.**","ref":"changelog.html#astro-version-0-5-0"},{"type":"extras","title":"Bug Fixes - Changelog","doc":"* Updates documentation to be clear about installation and setup requirements for `tz_world`\n\n* Fixes test data for São Paulo now that it no longer uses DST\n\n* Ensure `:astro` is started in test mode","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog","doc":"This primary focus of this release is to add lunar calculations for moon phase.\n\n* Adds `Astro.date_time_new_moon_before/1`\n\n* Adds `Astro.date_time_new_moon_at_or_after/1`\n\n* Adds `Astro.lunar_phase_at/1`\n\n* Adds `Astro.date_time_lunar_phase_at_or_before/2`\n\n* Adds `Astro.date_time_lunar_phase_at_or_after/2`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Astro version 0.4.0 - Changelog","doc":"This is the changelog for Astro version 0.4.0 released on February 16th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)","ref":"changelog.html#astro-version-0-4-0"},{"type":"extras","title":"Breaking Change - Changelog","doc":"* When no timezone is found the return is changed from `{:error, :timezone_not_found}` to `{:error, :time_zone_not_found}` to be consistent with Elixir and `TzData`.","ref":"changelog.html#breaking-change"},{"type":"extras","title":"Astro version 0.3.0 - Changelog","doc":"This is the changelog for Astro version 0.3.0 released on December 9th, 2019.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)","ref":"changelog.html#astro-version-0-3-0"},{"type":"extras","title":"Change in behaviour - Changelog","doc":"* Seconds are no longer truncated to zero when calculating datetimes and durations","ref":"changelog.html#change-in-behaviour"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `Astro.solar_noon/2` to return the true solar noon for a location and date\n\n* Add `Astro.hours_of_daylight/2` to return hours, minutes and seconds as a `Time.t()` representing the number of daylight hours for a give location and date\n\n* Add `Astro.sun_apparent_longitude/1` to return the apparent solar longitude on a given date. The result, a number of degrees between 0 and 360, can be used to determine the seasons.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Astro version 0.2.0 - Changelog","doc":"This is the changelog for Astro version 0.2.0 released on December 6th, 2019.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)","ref":"changelog.html#astro-version-0-2-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Add `Astro.equinox/2`and `Astro.solstice/2` to calculate solstices and equinoxes for a year. From these can be derived the seasons.\n\n* Add `Astro.Time.datetime_from_julian_days/1`\n\n* Add `Astro.Time.utc_datetime_from_terrestrial_datetime/1`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Astro version 0.1.0 - Changelog","doc":"This is the changelog for Astro version 0.1.0 released on December 5th, 2019.  For older changelogs please consult the release tag on [GitHub](https://github.com/kipcole9/astro/tags)","ref":"changelog.html#astro-version-0-1-0"},{"type":"extras","title":"Enhancements - Changelog","doc":"* Initial release includes `Astro.sunrise/3` and `Astro.sunset/3`.  See the readme for further roadmap details.","ref":"changelog.html#enhancements"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}